import { isCoValueClass } from "../internal.js";
export const SchemaInit = Symbol.for("SchemaInit");
export const InitValues = Symbol.for("InitValues");
export const ItemsSym = Symbol.for("items");
export const co = {
    string: {
        [SchemaInit]: "json",
    },
    number: {
        [SchemaInit]: "json",
    },
    boolean: {
        [SchemaInit]: "json",
    },
    literal: (_lit) => {
        return { [SchemaInit]: "json" };
    },
    json: () => {
        return { [SchemaInit]: "json" };
    },
    encoded: (arg) => {
        return { [SchemaInit]: { encoded: arg } };
    },
    ref: (arg) => {
        return { [SchemaInit]: arg };
    },
    items: ItemsSym,
};
export function isRefEncoded(schema) {
    return typeof schema === "function";
}
export function instantiateRefEncoded(schema, raw) {
    return isCoValueClass(schema)
        ? schema.fromRaw(raw)
        : schema(raw).fromRaw(raw);
}
import { Date } from "@effect/schema/Schema";
export const Encoders = {
    Date,
};
//# sourceMappingURL=schema.js.map